﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using task12;

namespace task12.Migrations
{
    [DbContext(typeof(SupervisorDbContext))]
    partial class SupervisorDbContextModelSnapshot : ModelSnapshot
    {
        protected override void BuildModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "3.1.7")
                .HasAnnotation("Relational:MaxIdentifierLength", 128)
                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

            modelBuilder.Entity("task12.Course", b =>
                {
                    b.Property<string>("CourseCode")
                        .HasColumnType("nvarchar(10)")
                        .HasMaxLength(10);

                    b.Property<int?>("LecturerId")
                        .HasColumnType("int");

                    b.Property<string>("Name")
                        .HasColumnType("nvarchar(max)");

                    b.HasKey("CourseCode");

                    b.HasIndex("LecturerId")
                        .IsUnique()
                        .HasFilter("[LecturerId] IS NOT NULL");

                    b.ToTable("Courses");

                    b.HasData(
                        new
                        {
                            CourseCode = "KOM1069",
                            LecturerId = 1,
                            Name = "Introduction to Stand-Up"
                        },
                        new
                        {
                            CourseCode = "FOT3030",
                            LecturerId = 2,
                            Name = "Advanced Nutmegging"
                        },
                        new
                        {
                            CourseCode = "ECON3069",
                            Name = "Advanced Grifting"
                        });
                });

            modelBuilder.Entity("task12.Enrollment", b =>
                {
                    b.Property<int>("StudentId")
                        .HasColumnType("int");

                    b.Property<string>("CourseCode")
                        .HasColumnType("nvarchar(10)")
                        .HasMaxLength(10);

                    b.HasKey("StudentId", "CourseCode");

                    b.HasIndex("CourseCode");

                    b.ToTable("Enrollments");

                    b.HasData(
                        new
                        {
                            StudentId = 3,
                            CourseCode = "FOT3030"
                        },
                        new
                        {
                            StudentId = 1,
                            CourseCode = "KOM1069"
                        });
                });

            modelBuilder.Entity("task12.Professor", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("CourseCode")
                        .HasColumnType("nvarchar(10)")
                        .HasMaxLength(10);

                    b.Property<string>("FirstName")
                        .HasColumnType("nvarchar(50)")
                        .HasMaxLength(50);

                    b.Property<string>("LastName")
                        .HasColumnType("nvarchar(50)")
                        .HasMaxLength(50);

                    b.HasKey("Id");

                    b.ToTable("Professors");

                    b.HasData(
                        new
                        {
                            Id = 1,
                            CourseCode = "KOM1069",
                            FirstName = "Dag",
                            LastName = "Langmyr"
                        },
                        new
                        {
                            Id = 2,
                            CourseCode = "FOT3030",
                            FirstName = "Tom",
                            LastName = "Norli"
                        },
                        new
                        {
                            Id = 3,
                            FirstName = "Raymond",
                            LastName = "Kvisvik"
                        });
                });

            modelBuilder.Entity("task12.Student", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("FirstName")
                        .HasColumnType("nvarchar(50)")
                        .HasMaxLength(50);

                    b.Property<string>("LastName")
                        .HasColumnType("nvarchar(50)")
                        .HasMaxLength(50);

                    b.Property<int?>("SupervisorId")
                        .HasColumnType("int");

                    b.HasKey("Id");

                    b.HasIndex("SupervisorId");

                    b.ToTable("Students");

                    b.HasData(
                        new
                        {
                            Id = 1,
                            FirstName = "Alex",
                            LastName = "Rosén",
                            SupervisorId = 1
                        },
                        new
                        {
                            Id = 2,
                            FirstName = "Christoffer",
                            LastName = "Schau"
                        },
                        new
                        {
                            Id = 3,
                            FirstName = "Ronny",
                            LastName = "Johnsen",
                            SupervisorId = 3
                        });
                });

            modelBuilder.Entity("task12.Course", b =>
                {
                    b.HasOne("task12.Professor", "Lecturer")
                        .WithOne("Course")
                        .HasForeignKey("task12.Course", "LecturerId");
                });

            modelBuilder.Entity("task12.Enrollment", b =>
                {
                    b.HasOne("task12.Course", "Course")
                        .WithMany("Enrollments")
                        .HasForeignKey("CourseCode")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("task12.Student", "Student")
                        .WithMany("Enrollments")
                        .HasForeignKey("StudentId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("task12.Student", b =>
                {
                    b.HasOne("task12.Professor", "Supervisor")
                        .WithMany("Supervisees")
                        .HasForeignKey("SupervisorId");
                });
#pragma warning restore 612, 618
        }
    }
}
